﻿---------------------------------
-- Addon:   MatheQuiz!
-- Author:  Neoxx, Nera'thor - EU
-- Version: 1
---------------------------------
local message;
local author;
local a;
local b;
local c;
local d;
-- Quizstatus 0 = no quiz, 1 = started, 2 = awaiting answer, 3 = correct answer received
local quizStatus;

function MQ_OnLoad()
	--Register slash commands!
	SLASH_MATHEQUIZ1 = '/mq', '/mathequiz';
	local function handler(msg)
		local command, rest = msg:match("^(%S*)%s*(.-)$");
			if (command == 'start') then
				MQ_Start();
			elseif (command == 'stopp') then
				MQ_Stop();
			elseif (command == 'topscore') then
				MQ_TopScores();
			elseif (command == 'resetscores') then
				MQ_ResetScore();
			elseif (command == 'resetsettings') then
				MQ_ResetSettings();
			elseif (command == 'ausgabe') then
				settings.outputChannel = string.upper(rest);
				DEFAULT_CHAT_FRAME:AddMessage('Ausgabe in '..settings.outputChannel..'!');
			elseif (command == 'topscoreamount') then
				settings.topScoreListNr = tonumber(rest);
				DEFAULT_CHAT_FRAME:AddMessage('Die Bestenliste hat nun den Bereich von '..rest..'.');
			elseif (command == 'antwortzeit') then
				settings.timeToAnswer = tonumber(rest);
				DEFAULT_CHAT_FRAME:AddMessage('Die Teilnehmer haben nun '..rest..' Sekunden zum Antworten!');
			elseif (command == 'wartezeit') then
				settings.timeBetweenQuestions = tonumber(rest);
				DEFAULT_CHAT_FRAME:AddMessage('Zwischen den Fragen sind es '..settings.timeBetweenQuestions..' Sekungen!');
			elseif (command == 'currentsettings') then
				DEFAULT_CHAT_FRAME:AddMessage('Ausgabe: '..settings.outputChannel..', Antwortzeit:'..settings.timeToAnswer..', Wartezeit: '..settings.timeBetweenQuestions..', Bereich der Bestenliste: '..settings.topScoreListNr);
			elseif (command == 'ausgabeinfo') then
				DEFAULT_CHAT_FRAME:AddMessage('Für "Sagen" wird SAY benutzt.');
				DEFAULT_CHAT_FRAME:AddMessage('Für "Schreien" wird YELL benutzt.');
				DEFAULT_CHAT_FRAME:AddMessage('Für "Gruppe" wird PARTY benutzt.');
				DEFAULT_CHAT_FRAME:AddMessage('Für "Gilde" wird GUILD benutzt.');
				DEFAULT_CHAT_FRAME:AddMessage('Für "Schlachtzug" wird RAID benutzt.');
				DEFAULT_CHAT_FRAME:AddMessage('Für "Offizier" wird OFFICER benutzt.');
				DEFAULT_CHAT_FRAME:AddMessage('Für "Schlachtzugwarnung" wird RAID_WARNING benutzt.');
				DEFAULT_CHAT_FRAME:AddMessage('Für "Schlachtfeld" wird BATTLEGROUND benutzt.');	
			else
				DEFAULT_CHAT_FRAME:AddMessage('Chatbefehle für MatheQuiz');
				DEFAULT_CHAT_FRAME:AddMessage('-----------------------------------------------------');
				DEFAULT_CHAT_FRAME:AddMessage('Tippe /mq start|stopp');
				DEFAULT_CHAT_FRAME:AddMessage('  --> startet/stoppt des Quizs.');
				DEFAULT_CHAT_FRAME:AddMessage('Tippe /mq ausgabe <Kanal>');
				DEFAULT_CHAT_FRAME:AddMessage('  --> setzt den Ausgabekanal. (siehe /mq ausgabeinfo)');
				DEFAULT_CHAT_FRAME:AddMessage('Tippe /mq ausgabeinfo');
				DEFAULT_CHAT_FRAME:AddMessage('  --> gibt Informationen zu den Kanalnamen.');
				DEFAULT_CHAT_FRAME:AddMessage('Tippe /mq topscore');
				DEFAULT_CHAT_FRAME:AddMessage('  --> zeigt die Bestenliste.');
				DEFAULT_CHAT_FRAME:AddMessage('Tippe /mq currentsettings');
				DEFAULT_CHAT_FRAME:AddMessage('  --> zeigt die aktuellen Einstellungen.');
				DEFAULT_CHAT_FRAME:AddMessage('Tippe /mq resetscore');
				DEFAULT_CHAT_FRAME:AddMessage('  --> setzt alle Scores zurück.');
				DEFAULT_CHAT_FRAME:AddMessage('Tippe /mq resetsettings');
				DEFAULT_CHAT_FRAME:AddMessage('  --> setzt alle Einstellungen zurück.');
				DEFAULT_CHAT_FRAME:AddMessage('Tippe /mq topscoreamount <Nummer>');
				DEFAULT_CHAT_FRAME:AddMessage('  --> passt den Bereich der Bestenliste an.');
				DEFAULT_CHAT_FRAME:AddMessage('Tippe /mq antwortzeit <Nummer>');
				DEFAULT_CHAT_FRAME:AddMessage('  --> ändert die Antwortzeit.');
				DEFAULT_CHAT_FRAME:AddMessage('Tippe /mq wartezeit <Nummer>');
				DEFAULT_CHAT_FRAME:AddMessage('  --> ändert die Wartezeit zwischen den Fragen.');
			end
	end	
	
	SlashCmdList["MATHEQUIZ"] = handler;
	if (settings ~= nil) then
		settings = settings;
	else
		settings = { outputChannel = 'GUILD', topScoreListNr = 3, timeToAnswer = 15, timeBetweenQuestions = 5};
	end	
	
	if (scores ~= nil) then
		scores = scores;
	else
		scores = { };
	end

end

function MQ_Stop()
	quizStatus = 0;
	MatheQuizFrame:UnregisterEvent('CHAT_MSG_'..settings.outputChannel);
	SendChatMessage('MatheQuiz gestoppt. Powered by Neoxx!', settings.outputChannel);
	MatheQuizFrame:SetScript('OnUpdate', nil);
	MQ_TopScores();
end

function MQ_Start()
	SendChatMessage('MatheQuiz startet in '..settings.timeBetweenQuestions..' Sekunden. Powered by Neoxx!', settings.outputChannel);
	quizStatus = 1;
	MatheQuizFrame:SetScript("OnUpdate", MQ_OnUpdate); 
	MatheQuizFrame.TimeSinceLastUpdate = 0;
end

function MQ_CreateQuestion()
	local z = math.random(0, 3);
	if (z == 0) then
		-- + 
		a = math.random(0, 200);
		b = math.random(0, 200);
		c = a + b;
		d = '+'
	elseif (z == 1) then
		-- -
		a = math.random(0, 200);
		b = math.random(0, 200);
		c = a - b;
		d = '-';
	elseif (z == 2) then
		-- *
		a = math.random(0, 20);
		b = math.random(0, 20);
		c = a * b;
		d = '*';
	elseif (z == 3) then
		-- /
		a = math.random(0, 100);
		b = math.random(1, 5);
		c = a / b;
		d = '/'
	end
	MatheQuizFrame:RegisterEvent('CHAT_MSG_'..settings.outputChannel);
	SendChatMessage('Was ist '..a..d..b..' ?', settings.outputChannel);
	quizStatus = 2;
end

function MQ_OnUpdate(self, elapsed)
	if (quizStatus == 0) then
		return;
	elseif (quizStatus == 1) then
		MatheQuizFrame.TimeSinceLastUpdate = MatheQuizFrame.TimeSinceLastUpdate + elapsed;
		if (MatheQuizFrame.TimeSinceLastUpdate > settings.timeBetweenQuestions) then
			MQ_CreateQuestion();
			timeWarning = 0;
			MatheQuizFrame.TimeSinceLastUpdate = 0;
		else
			return;
		end
	elseif (quizStatus == 2) then
		MatheQuizFrame.TimeSinceLastUpdate = MatheQuizFrame.TimeSinceLastUpdate + elapsed;
		if ((MatheQuizFrame.TimeSinceLastUpdate > (settings.timeToAnswer / 2)) and (timeWarning == 0)) then
			SendChatMessage((settings.timeToAnswer / 2)..' Sekungen übrig!', settings.outputChannel);
			timeWarning = 1;
		elseif (MatheQuizFrame.TimeSinceLastUpdate > settings.timeToAnswer) then
			SendChatMessage('Die Zeit ist um! Die Antwort war '..c..'!', settings.outputChannel);
			quizStatus = 3;
		end
	elseif (quizStatus == 3) then
		quizStatus = 1;
		MatheQuizFrame.TimeSinceLastUpdate = 0;
	end
end

function MQ_TopScores()
	MQ_SortTopScore();
	local x = 1;
	SendChatMessage('IQ Bestenliste', settings.outputChannel);
	while x <= settings.topScoreListNr do
		if (scores[x] ~= nil) then
			SendChatMessage(scores[x].name..': '..scores[x].points, settings.outputChannel);
			x = x + 1;
		else
			return;
		end
	end
end

function MQ_SortTopScore()
	table.sort(scores, function(a1,a2) return a1.points > a2.points end)
end
	
function MQ_EventHandler(event, ...)
	if (event == 'CHAT_MSG_'..settings.outputChannel and quizStatus == 2) then
		message = arg1;
		author = arg2;
		if (message == tostring(c)) then
			playerData = MQ_GetPlayerData(author)		
			playerData.points = playerData.points + 1;
			SendChatMessage(playerData.name..' liegt richtig und hat nun einen IQ von '..playerData.points..'!', settings.outputChannel);			
			MatheQuizFrame:UnregisterEvent('CHAT_MSG_'..settings.outputChannel);
			quizStatus = 3;
		end
	end
end

function MQ_ResetScore()
	scores = {};
	DEFAULT_CHAT_FRAME:AddMessage('Scores wurden zurückgesetzt!', 1.0, 0.0, 0.0);
end

function MQ_ResetSettings()
	settings = { outputChannel = 'GUILD', topScoreListNr = 3, timeToAnswer = 15, timeBetweenQuestions = 5};
	DEFAULT_CHAT_FRAME:AddMessage('Einstellungen wurden zurückgesetzt!', 1.0, 0.0, 0.0);
end
	
	function MQ_GetPlayerData(playername)
	if (scores[1] ~= nil) then
		for i,v in ipairs(scores) do
			if (v.name == playername) then
				return v;
			end
		end		
		playerData = {name = playername, points = 0};
		table.insert(scores, playerData);
		return playerData;
	else 
		playerData = {name = playername, points = 0};
		table.insert(scores, playerData);
		return playerData;	
	end
end